$(() => {
$('#pie').dxPieChart({
palette: 'Vintage',
dataSource,
commonAnnotationSettings: {
type: 'image',
image: {
height: 60,
width: 90,
},
color: 'transparent',
border: {
color: 'transparent',
},
paddingLeftRight: 0,
paddingTopBottom: 0,
tooltipTemplate,
},
annotations: getAnnotationSources(),
series: [{
argumentField: 'country',
valueField: 'gold',
label: {
visible: true,
position: 'inside',
radialOffset: 83,
backgroundColor: 'transparent',
font: {
size: 16,
weight: 600,
},
},
}],
tooltip: {
paddingLeftRight: 12,
paddingTopBottom: 10,
},
legend: {
visible: false,
},
title: 'Ice Hockey World Championship Gold Medal Winners',
});
function getAnnotationSources() {
annotations.forEach((a, index, array) => {
array[index].image = `../../../../images/flags/3x2/${a.argument.replace(/\s/, '')}.svg`;
array[index].data = $.extend({}, dataSource.filter((d) => d.country === a.argument)[0]);
if (a.location === 'edge') {
array[index] = $.extend({}, a, edgeAnnotationSettings);
}
});
return annotations;
}
function tooltipTemplate(annotation, container) {
const { data } = annotation;
const contentItems = ["<div class='medal-tooltip'>",
"<div class='country-name'></div>",
"<div class='gold'><span class='caption'>Gold</span>: </div>",
"<div class='silver'><span class='caption'>Silver</span>: </div>",
"<div class='bronze'><span class='caption'>Bronze</span>: </div>",
'</div>'];
const content = $(contentItems.join(''));
content.find('.country-name').text(data.country);
if (data.oldCountryName) {
content.find('.country-name').append('<br/>').append(document.createTextNode(data.oldCountryName));
}
content.find('.gold').append(document.createTextNode(data.gold));
content.find('.silver').append(document.createTextNode(data.silver));
content.find('.bronze').append(document.createTextNode(data.bronze));
content.appendTo(container);
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/22.1.4/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="pie"></div>
</div>
</body>
</html>
#pie {
height: 440px;
}
.medal-tooltip {
font-size: 12px;
}
.medal-tooltip .country-name {
font-size: 14px;
font-weight: 700;
margin: 5px 0 10px 0;
}
.medal-tooltip .caption {
font-weight: 600;
}
const annotations = [{
argument: 'Russia',
offsetX: 15,
offsetY: 5,
}, {
argument: 'Canada',
offsetY: 10,
}, {
argument: 'Czech Republic',
offsetX: -5,
offsetY: -35,
}, {
argument: 'Sweden',
offsetX: 20,
offsetY: -25,
}, {
argument: 'Finland',
location: 'edge',
offsetX: 45,
offsetY: -85,
}, {
argument: 'United States',
location: 'edge',
offsetX: 85,
offsetY: -45,
}, {
argument: 'Great Britain',
location: 'edge',
offsetX: 81,
offsetY: 15,
}, {
argument: 'Slovakia',
location: 'edge',
offsetX: 45,
offsetY: 80,
}];
const edgeAnnotationSettings = {
color: '#aaaaaa',
border: {
color: '#aaaaaa',
},
shadow: {
opacity: 0.3,
},
};
const dataSource = [{
country: 'Russia',
oldCountryName: 'Soviet Union',
gold: 27,
silver: 10,
bronze: 10,
}, {
country: 'Canada',
gold: 26,
silver: 15,
bronze: 9,
}, {
country: 'Czech Republic',
oldCountryName: 'Czechoslovakia',
gold: 12,
silver: 13,
bronze: 21,
}, {
country: 'Sweden',
gold: 11,
silver: 19,
bronze: 17,
}, {
country: 'Finland',
gold: 3,
silver: 8,
bronze: 3,
}, {
country: 'United States',
gold: 2,
silver: 9,
bronze: 8,
}, {
country: 'Great Britain',
gold: 1,
silver: 2,
bronze: 2,
}, {
country: 'Slovakia',
gold: 1,
silver: 2,
bronze: 1,
}];

import React from 'react';
import PieChart, {
CommonAnnotationSettings,
Annotation,
Image,
Border,
Shadow,
Series,
Label,
Font,
Tooltip,
Legend,
} from 'devextreme-react/pie-chart';
import { dataSource, getAnnotationSources } from './data.js';
import TooltipTemplate from './TooltipTemplate.js';
const annotationSources = getAnnotationSources();
export default function App() {
return (
<PieChart
id="pie"
palette="Vintage"
dataSource={dataSource}
title="Ice Hockey World Championship Gold Medal Winners"
>
<CommonAnnotationSettings
type="image"
color="transparent"
paddingLeftRight={0}
paddingTopBottom={0}
tooltipRender={TooltipTemplate}
>
<Image
height={60}
width={90}
/>
<Border color="transparent" />
</CommonAnnotationSettings>
{
annotationSources.map((item) => (
<Annotation
key={item.country}
argument={item.country}
data={item.data}
location={item.location}
offsetX={item.offsetX}
offsetY={item.offsetY}
color={item.color}>
<Image url={item.image} />
<Border color={item.borderColor} />
<Shadow opacity={item.shadowOpacity} />
</Annotation>
))
}
<Series
argumentField="country"
valueField="gold">
<Label
visible
position="inside"
radialOffset={83}
backgroundColor="transparent">
<Font
size={16}
weight={600}
/>
</Label>
</Series>
<Tooltip
paddingLeftRight={12}
paddingTopBottom={10}
/>
<Legend visible={false} />
</PieChart>
);
}
import React from 'react';
export default function TooltipTemplate(annotation) {
const { data } = annotation;
return (
<div className='medal-tooltip'>
<div className='country-name'>{data.country}
{data.oldCountryName && <br />}{data.oldCountryName}
</div>
<div className='gold'>
<span className='caption'>Gold</span>: {data.gold}
</div>
<div className='silver'>
<span className='caption'>Silver</span>: {data.silver}
</div>
<div className='bronze'>
<span className='caption'>Bronze</span>: {data.bronze}
</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#pie {
height: 440px;
}
.medal-tooltip {
font-size: 12px;
}
.medal-tooltip .country-name {
font-size: 14px;
font-weight: 700;
margin: 5px 0 10px 0;
}
.medal-tooltip .caption {
font-weight: 600;
}
const annotationSources = [{
country: 'Russia',
offsetX: 15,
offsetY: 5,
}, {
country: 'Canada',
offsetY: 10,
}, {
country: 'Czech Republic',
offsetX: -5,
offsetY: -35,
}, {
country: 'Sweden',
offsetX: 20,
offsetY: -25,
}, {
country: 'Finland',
location: 'edge',
offsetX: 45,
offsetY: -85,
}, {
country: 'United States',
location: 'edge',
offsetX: 85,
offsetY: -45,
}, {
country: 'Great Britain',
location: 'edge',
offsetX: 81,
offsetY: 15,
}, {
country: 'Slovakia',
location: 'edge',
offsetX: 45,
offsetY: 80,
}];
const edgeAnnotationSettings = {
color: '#aaaaaa',
borderColor: '#aaaaaa',
shadowOpacity: 0.3,
};
export const dataSource = [{
country: 'Russia',
oldCountryName: 'Soviet Union',
gold: 27,
silver: 10,
bronze: 10,
}, {
country: 'Canada',
gold: 26,
silver: 15,
bronze: 9,
}, {
country: 'Czech Republic',
oldCountryName: 'Czechoslovakia',
gold: 12,
silver: 13,
bronze: 21,
}, {
country: 'Sweden',
gold: 11,
silver: 19,
bronze: 17,
}, {
country: 'Finland',
gold: 3,
silver: 8,
bronze: 3,
}, {
country: 'United States',
gold: 2,
silver: 9,
bronze: 8,
}, {
country: 'Great Britain',
gold: 1,
silver: 2,
bronze: 2,
}, {
country: 'Slovakia',
gold: 1,
silver: 2,
bronze: 1,
}];
export function getAnnotationSources() {
const annotations = [];
for (let i = 0; i < annotationSources.length; i += 1) {
const annotation = annotationSources[i];
const { country } = annotation;
const image = `../../../../images/flags/3x2/${country.replace(/\s/, '')}.svg`;
const data = { ...dataSource.filter((d) => (d.country === country))[0] };
annotations.push({
...annotation,
image,
data,
...(annotation.location === 'edge' ? edgeAnnotationSettings : {}),
});
}
return annotations;
}
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.4/cjs',
'devextreme-react': 'npm:devextreme-react@22.1.4',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.63/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.32/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<DxPieChart
id="pie"
:data-source="dataSource"
palette="Vintage"
title="Ice Hockey World Championship Gold Medal Winners"
>
<DxCommonAnnotationSettings
:padding-left-right="0"
:padding-top-bottom="0"
type="image"
color="transparent"
tooltip-template="tooltipTemplate"
>
<DxImage
:height="60"
:width="90"
/>
<DxBorder color="transparent"/>
</DxCommonAnnotationSettings>
<DxAnnotation
v-for="item in annotations"
:key="item.country"
:argument="item.country"
:data="item.data"
:location="item.location"
:offset-x="item.offsetX"
:offset-y="item.offsetY"
:color="item.color"
>
<DxImage :url="item.image"/>
<DxBorder :color="item.borderColor"/>
<DxShadow :opacity="item.shadowOpacity"/>
</DxAnnotation>
<DxSeries
argument-field="country"
value-field="gold"
>
<DxLabel
:visible="true"
:radial-offset="83"
position="inside"
background-color="transparent"
>
<DxFont
:size="16"
:weight="600"
/>
</DxLabel>
</DxSeries>
<DxTooltip
:padding-left-right="12"
:padding-top-bottom="10"
/>
<DxLegend :visible="false"/>
<template #tooltipTemplate="{ data }">
<TooltipTemplate :annotation="data"/>
</template>
</DxPieChart>
</template>
<script>
import DxPieChart, {
DxCommonAnnotationSettings,
DxAnnotation,
DxImage,
DxBorder,
DxShadow,
DxSeries,
DxLabel,
DxFont,
DxTooltip,
DxLegend,
} from 'devextreme-vue/pie-chart';
import { dataSource, getAnnotationSources } from './data.js';
import TooltipTemplate from './TooltipTemplate.vue';
export default {
components: {
DxPieChart,
DxCommonAnnotationSettings,
DxAnnotation,
DxImage,
DxBorder,
DxShadow,
DxSeries,
DxLabel,
DxFont,
DxTooltip,
DxLegend,
TooltipTemplate,
},
data() {
return {
dataSource,
annotations: getAnnotationSources(),
};
},
};
</script>
<style>
#pie {
height: 440px;
}
</style>
<template>
<div class="medal-tooltip">
<div class="country-name">{{ data.country }}
<br v-if="data.oldCountryName">{{ data.oldCountryName }}
</div>
<div class="gold">
<span class="caption">Gold</span>: {{ data.gold }}
</div>
<div class="silver">
<span class="caption">Silver</span>: {{ data.silver }}
</div>
<div class="bronze">
<span class="caption">Bronze</span>: {{ data.bronze }}
</div>
</div>
</template>
<script>
export default {
props: {
annotation: {
type: Object,
default: () => ({}),
},
},
data() {
return {
data: this.annotation.data,
};
},
};
</script>
<style>
.medal-tooltip {
font-size: 12px;
}
.medal-tooltip .country-name {
font-size: 14px;
font-weight: 700;
margin: 5px 0 10px 0;
}
.medal-tooltip .caption {
font-weight: 600;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
const annotationSources = [{
country: 'Russia',
offsetX: 15,
offsetY: 5,
}, {
country: 'Canada',
offsetY: 10,
}, {
country: 'Czech Republic',
offsetX: -5,
offsetY: -35,
}, {
country: 'Sweden',
offsetX: 20,
offsetY: -25,
}, {
country: 'Finland',
location: 'edge',
offsetX: 45,
offsetY: -85,
}, {
country: 'United States',
location: 'edge',
offsetX: 85,
offsetY: -45,
}, {
country: 'Great Britain',
location: 'edge',
offsetX: 81,
offsetY: 15,
}, {
country: 'Slovakia',
location: 'edge',
offsetX: 45,
offsetY: 80,
}];
const edgeAnnotationSettings = {
color: '#aaaaaa',
borderColor: '#aaaaaa',
shadowOpacity: 0.3,
};
export const dataSource = [{
country: 'Russia',
oldCountryName: 'Soviet Union',
gold: 27,
silver: 10,
bronze: 10,
}, {
country: 'Canada',
gold: 26,
silver: 15,
bronze: 9,
}, {
country: 'Czech Republic',
oldCountryName: 'Czechoslovakia',
gold: 12,
silver: 13,
bronze: 21,
}, {
country: 'Sweden',
gold: 11,
silver: 19,
bronze: 17,
}, {
country: 'Finland',
gold: 3,
silver: 8,
bronze: 3,
}, {
country: 'United States',
gold: 2,
silver: 9,
bronze: 8,
}, {
country: 'Great Britain',
gold: 1,
silver: 2,
bronze: 2,
}, {
country: 'Slovakia',
gold: 1,
silver: 2,
bronze: 1,
}];
export function getAnnotationSources() {
const annotations = [];
for (let i = 0; i < annotationSources.length; i += 1) {
const annotation = annotationSources[i];
const { country } = annotation;
const image = `../../../../images/flags/3x2/${country.replace(/\s/, '')}.svg`;
const data = { ...dataSource.filter((d) => (d.country === country))[0] };
annotations.push({
...annotation,
image,
data,
...(annotation.location === 'edge' ? edgeAnnotationSettings : {}),
});
}
return annotations;
}
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'root:': '../../../../../',
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js',
'demo-ts-loader': 'root:utils/demo-ts-loader.js',
'svg-loader': 'root:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.5/cjs',
'devextreme-vue': 'npm:devextreme-vue@23.1.5',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.1/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.48/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

<dx-pie-chart id="pie" palette="Vintage" [dataSource]="champions">
<dxo-common-annotation-settings
type="image"
color="transparent"
[paddingLeftRight]="0"
[paddingTopBottom]="0"
tooltipTemplate="tooltipTemplate"
>
<dxo-image [height]="60" [width]="90"></dxo-image>
<dxo-border color="transparent"></dxo-border>
</dxo-common-annotation-settings>
<dxi-annotation
*ngFor="let item of annotations"
[argument]="item.country"
[data]="item.data"
[location]="item.location"
[offsetX]="item.offsetX"
[offsetY]="item.offsetY"
[color]="item.color"
>
<dxo-image [url]="item.image"></dxo-image>
<dxo-border [color]="item.borderColor"></dxo-border>
<dxo-shadow [opacity]="item.shadowOpacity"></dxo-shadow>
</dxi-annotation>
<dxi-series argumentField="country" valueField="gold">
<dxo-label
[visible]="true"
position="inside"
[radialOffset]="83"
backgroundColor="transparent"
>
<dxo-font [size]="16" [weight]="600"></dxo-font>
</dxo-label>
</dxi-series>
<dxo-tooltip [paddingLeftRight]="12" [paddingTopBottom]="10"></dxo-tooltip>
<dxo-legend [visible]="false"></dxo-legend>
<dxo-title
text="Ice Hockey World Championship Gold Medal Winners"
></dxo-title>
<div *dxTemplate="let annotation of 'tooltipTemplate'" class="medal-tooltip">
<div class="country-name"
>{{ annotation.data.country }}
<br *ngIf="annotation.data.oldCountryName" />{{
annotation.data.oldCountryName
}}
</div>
<div class="gold">
<span class="caption">Gold</span>: {{ annotation.data.gold }}
</div>
<div class="silver">
<span class="caption">Silver</span>: {{ annotation.data.silver }}
</div>
<div class="bronze">
<span class="caption">Bronze</span>: {{ annotation.data.bronze }}
</div>
</div>
</dx-pie-chart>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxPieChartModule } from 'devextreme-angular';
import { MedalistData, AnnotationInfo, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
})
export class AppComponent {
champions: MedalistData[];
annotations: AnnotationInfo[];
constructor(service: Service) {
this.champions = service.getChampionsData();
this.annotations = service.getAnnotationSources();
}
}
@NgModule({
imports: [
BrowserModule,
DxPieChartModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #pie {
height: 440px;
}
::ng-deep .medal-tooltip {
font-size: 12px;
}
::ng-deep .medal-tooltip .country-name {
font-size: 14px;
font-weight: 700;
margin: 5px 0 10px 0;
}
::ng-deep .medal-tooltip .caption {
font-weight: 600;
}
import {
Injectable,
} from '@angular/core';
export class MedalistData {
country?: string;
oldCountryName?: string;
gold?: number;
silver?: number;
bronze?: number;
}
export class AnnotationInfo {
country: string;
data?: MedalistData;
image?: string;
location?: string;
offsetX?: number;
offsetY?: number;
color?: string;
borderColor?: string;
shadowOpacity?: number;
}
const champions: MedalistData[] = [{
country: 'Russia',
oldCountryName: 'Soviet Union',
gold: 27,
silver: 10,
bronze: 10,
}, {
country: 'Canada',
gold: 26,
silver: 15,
bronze: 9,
}, {
country: 'Czech Republic',
oldCountryName: 'Czechoslovakia',
gold: 12,
silver: 13,
bronze: 21,
}, {
country: 'Sweden',
gold: 11,
silver: 19,
bronze: 17,
}, {
country: 'Finland',
gold: 3,
silver: 8,
bronze: 3,
}, {
country: 'United States',
gold: 2,
silver: 9,
bronze: 8,
}, {
country: 'Great Britain',
gold: 1,
silver: 2,
bronze: 2,
}, {
country: 'Slovakia',
gold: 1,
silver: 2,
bronze: 1,
}];
const annotationSources: AnnotationInfo[] = [{
country: 'Russia',
offsetX: 15,
offsetY: 5,
}, {
country: 'Canada',
offsetY: 10,
}, {
country: 'Czech Republic',
offsetX: -5,
offsetY: -35,
}, {
country: 'Sweden',
offsetX: 20,
offsetY: -25,
}, {
country: 'Finland',
location: 'edge',
offsetX: 45,
offsetY: -85,
}, {
country: 'United States',
location: 'edge',
offsetX: 85,
offsetY: -45,
}, {
country: 'Great Britain',
location: 'edge',
offsetX: 81,
offsetY: 15,
}, {
country: 'Slovakia',
location: 'edge',
offsetX: 45,
offsetY: 80,
}];
const edgeAnnotationSettings = {
color: '#aaaaaa',
borderColor: '#aaaaaa',
shadowOpacity: 0.3,
};
@Injectable()
export class Service {
getChampionsData(): MedalistData[] {
return champions;
}
getAnnotationSources(): AnnotationInfo[] {
const annotations: AnnotationInfo[] = [];
for (let i = 0; i < annotationSources.length; i++) {
const annotation = annotationSources[i];
const country = annotation.country;
const image = `../../../../images/flags/3x2/${country.replace(/\s/, '')}.svg`;
const data = { ...champions.filter((d) => (d.country === country))[0] };
annotations.push({
...annotation,
image,
data,
...(annotation.location === 'edge' ? edgeAnnotationSettings : {}),
});
}
return annotations;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.16',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.16',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.16',
'@angular/forms': 'npm:@angular/forms@12.2.16',
'@angular/common': 'npm:@angular/common@12.2.16',
'@angular/compiler': 'npm:@angular/compiler@12.2.16',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.3/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.1.3/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.57',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.30',
'devextreme-angular': 'npm:devextreme-angular@22.1.3',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.16/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.1.3/*/package.json',
'npm:devextreme-angular@22.1.3/ui/*/package.json',
'npm:devextreme-angular@22.1.3/package.json',
'npm:devexpress-diagram@2.1.57/package.json',
'npm:devexpress-gantt@4.1.30/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.11.4/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>